# CPLStringList Class Reference

String list class designed around our use of C "char**" string lists. More...

`#include <cpl_string.h>`

List of all members.

## Public Member Functions
| CPLStringList (char **papszList, int bTakeOwnership=TRUE)
| CPLStringList constructor.
| CPLStringList (const CPLStringList &oOther)
| Copy constructor.
CPLStringList & | Clear ()
| Clear the string list.
int | size () const
int | Count () const
CPLStringList & | AddString (const char *pszNewString)
| Add a string to the list.
CPLStringList & | AddStringDirectly (char *pszNewString)
| Add a string to the list.
CPLStringList & | InsertString (int nInsertAtLineNo, const char *pszNewLine)
| Insert into the list at identified location.
CPLStringList & | InsertStringDirectly (int nInsertAtLineNo, char *pszNewLine)
| Insert into the list at identified location.
int | FindString (const char *pszTarget) const
int | PartialFindString (const char *pszNeedle) const
int | FindName (const char *pszName) const
| Get index of given name/value keyword.
int | FetchBoolean (const char *pszKey, int bDefault) const
| Check for boolean key value.
const char * | FetchNameValue (const char *pszKey) const
| Fetch value associated with this key name.
const char * | FetchNameValueDef (const char *pszKey, const char *pszDefault) const
| Fetch value associated with this key name.
CPLStringList & | AddNameValue (const char *pszKey, const char *pszValue)
| A a name=value entry to the list.
CPLStringList & | SetNameValue (const char *pszKey, const char *pszValue)
| Set name=value entry in the list.
CPLStringList & | Assign (char **papszList, int bTakeOwnership=TRUE)
| Assign a list of strings.
CPLStringList & | operator= (char **papszListIn)
CPLStringList & | operator= (const CPLStringList &oOther)
char * | operator[] (int i)
| Fetch entry "i".
char * | operator[] (size_t i)
const char * | operator[] (int i) const
const char * | operator[] (size_t i) const
char ** | List ()
char ** | StealList ()
| Seize ownership of underlying string array.
CPLStringList & | Sort ()
| Sort the entries in the list and mark list sorted.
int | IsSorted () const
| operator char ** (void)

## Detailed Description

String list class designed around our use of C "char**" string lists.

## Constructor & Destructor Documentation

CPLStringList::CPLStringList | ( | char ** | papszListIn,
|  | int | bTakeOwnership = `TRUE` |
| ) |  |  |

CPLStringList constructor.

Parameters:

  | papszListIn | the NULL terminated list of strings to consume.
  | bTakeOwnership | TRUE if the CPLStringList should take ownership of the list of strings which implies responsibility to free them.

References Assign().

## Member Function Documentation

int CPLStringList::Count | ( |  | ) | const

Returns:
  count of strings in the list, zero if empty.

Referenced by AddStringDirectly(), CSLTokenizeString2(), InsertStringDirectly(), operator[](), SetNameValue(), and Sort().

CPLStringList & CPLStringList::AddString | ( | const char * | pszNewString | ) |

Add a string to the list.

A copy of the passed in string is made and inserted in the list.

Parameters:

  | pszNewString | the string to add to the list.

References AddStringDirectly().

Referenced by CSLTokenizeString2().

CPLStringList & CPLStringList::AddStringDirectly | ( | char * | pszNewString | ) |

Add a string to the list.

This method is similar to AddString(), but ownership of the pszNewString is transferred to the CPLStringList class.

Parameters:

  | pszNewString | the string to add to the list.

References Count().

Referenced by AddNameValue(), and AddString().

CPLStringList * CPLStringList::InsertString | ( | int | nInsertAtLineNo,
|  | const char * | pszNewLine |
| ) |  |  | `[inline]`

Insert into the list at identified location.

This method will insert a string into the list at the identified location. The insertion point must be within or at the end of the list. The following entries are pushed down to make space.

Parameters:

  | nInsertAtLineNo | the line to insert at, zero to insert at front.
  | pszNewLine | to the line to insert. This string will be copied.

CPLStringList & CPLStringList::InsertStringDirectly | ( | int | nInsertAtLineNo,
|  | char * | pszNewLine |
| ) |  |  |

Insert into the list at identified location.

This method will insert a string into the list at the identified location. The insertion point must be within or at the end of the list. The following entries are pushed down to make space.

Parameters:

  | nInsertAtLineNo | the line to insert at, zero to insert at front.
  | pszNewLine | to the line to insert, the ownership of this string will be taken over the by the object. It must have been allocated on the heap.

References Count().

Referenced by AddNameValue().

int CPLStringList::FindName | ( | const char * | pszKey | ) | const

Get index of given name/value keyword.

Note that this search is for a line in the form name=value or name:value. Use FindString() or PartialFindString() for searches not based on name=value pairs.

Parameters:

  | pszKey | the name to search for.

Returns:
  the string list index of this name, or -1 on failure.

Referenced by FetchNameValue(), and SetNameValue().

int CPLStringList::FetchBoolean | ( | const char * | pszKey,
|  | int | bDefault |
| ) |  |  | const

Check for boolean key value.

In a CPLStringList of "Name=Value" pairs, look to see if there is a key with the given name, and if it can be interpreted as being TRUE. If the key appears without any "=Value" portion it will be considered true. If the value is NO, FALSE or 0 it will be considered FALSE otherwise if the key appears in the list it will be considered TRUE. If the key doesn't appear at all, the indicated default value will be returned.

Parameters:

  | pszKey | the key value to look for (case insensitive).
  | bDefault | the value to return if the key isn't found at all.

Returns:
  TRUE or FALSE

References FetchNameValue().

const char * CPLStringList::FetchNameValue | ( | const char * | pszName | ) | const

Fetch value associated with this key name.

If this list sorted, a fast binary search is done, otherwise a linear scan is done. Name lookup is case insensitive.

Parameters:

  | pszName | the key name to search for.

Returns:
  the corresponding value or NULL if not found. The returned string should not be modified and points into internal object state that may change on future calls.

References FindName().

Referenced by FetchBoolean(), and FetchNameValueDef().

const char * CPLStringList::FetchNameValueDef | ( | const char * | pszName,
|  | const char * | pszDefault |
| ) |  |  | const

Fetch value associated with this key name.

If this list sorted, a fast binary search is done, otherwise a linear scan is done. Name lookup is case insensitive.

Parameters:

  | pszName | the key name to search for.
  | pszDefault | the default value returned if the named entry isn't found.

Returns:
  the corresponding value or the passed default if not found.

References FetchNameValue().

CPLStringList & CPLStringList::AddNameValue | ( | const char * | pszKey,
|  | const char * | pszValue |
| ) |  |  |

A a name=value entry to the list.

A key=value string is prepared and appended to the list. There is no check for other values for the same key in the list.

Parameters:

  | pszKey | the key name to add.
  | pszValue | the key value to add.

References AddStringDirectly(), and InsertStringDirectly().

Referenced by SetNameValue().

CPLStringList & CPLStringList::SetNameValue | ( | const char * | pszKey,
|  | const char * | pszValue |
| ) |  |  |

Set name=value entry in the list.

Similar to AddNameValue(), except if there is already a value for the key in the list it is replaced instead of adding a new entry to the list. If pszValue is NULL any existing key entry is removed.

Parameters:

  | pszKey | the key name to add.
  | pszValue | the key value to add.

References AddNameValue(), Count(), and FindName().

CPLStringList & CPLStringList::Assign | ( | char ** | papszListIn,
|  | int | bTakeOwnership = `TRUE` |
| ) |  |  |

Assign a list of strings.

Parameters:

  | papszListIn | the NULL terminated list of strings to consume.
  | bTakeOwnership | TRUE if the CPLStringList should take ownership of the list of strings which implies responsibility to free them.

Returns:
  a reference to the CPLStringList on which it was invoked.

References Clear().

Referenced by CPLStringList(), and CSLTokenizeString2().

char * CPLStringList::operator[] | ( | int | i | ) |

Fetch entry "i".

Fetches the requested item in the list. Note that the returned string remains owned by the CPLStringList. If "i" is out of range NULL is returned.

Parameters:

  | i | the index of the list item to return.

Returns:
  selected entry in the list.

References Count().

char ** CPLStringList::StealList | ( |  | ) |

Seize ownership of underlying string array.

This method is simmilar to List(), except that the returned list is now owned by the caller and the CPLStringList is emptied.

Returns:
  the C style string list.

Referenced by CSLTokenizeString2().

CPLStringList & CPLStringList::Sort | ( |  | ) |

Sort the entries in the list and mark list sorted.

Note that once put into "sorted" mode, the CPLStringList will attempt to keep things in sorted order through calls to AddString(), AddStringDirectly(), AddNameValue(), SetNameValue(). Complete list assignments (via Assign() and operator= will clear the sorting state. When in sorted order FindName(), FetchNameValue() and FetchNameValueDef() will do a binary search to find the key, substantially improve lookup performance in large lists.

References Count().

The documentation for this class was generated from the following files:

- cpl_string.h
- cplstringlist.cpp

Generated for GDAL by 1.5.6.